﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraFollowCharacter : MonoBehaviour
{
    [SerializeField] private Transform character;
    [SerializeField] private Vector3 positionOffset;
    [SerializeField] private float lerpSpeed;

    // Start is called before the first frame update
    void Start()
    {
        transform.position = character.position + positionOffset;
    }

    // Update is called once per frame
    void Update()
    {
        transform.position = Vector3.Lerp(transform.position, character.position + positionOffset, Time.deltaTime * lerpSpeed);
    }
}
