﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[CreateAssetMenu(fileName = "GameEventFloat", menuName = "Custom/Events/New GameEvent with float param", order = 1)]
public class GameEventFloat : ScriptableObject
{
    private List<GameEventListenerFloat> listeners = new List<GameEventListenerFloat>();

    public void Raise(float f)
    {
        for (int i = listeners.Count - 1; i >= 0; i--)
        {
            listeners[i].OnEventRaised(f);
        }
    }

    public void RegisterListener(GameEventListenerFloat listener)
    {
        listeners.Add(listener);
    }

    public void UnregisterListeners(GameEventListenerFloat listener)
    {
        listeners.Remove(listener);
    }
}
